'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Bar = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _pure = require('../../utils/pure');

var _EventListener = require('../EventListener/EventListener');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Bar = function (_React$Component) {
    _inherits(Bar, _React$Component);

    function Bar() {
        _classCallCheck(this, Bar);

        var _this = _possibleConstructorReturn(this, (Bar.__proto__ || Object.getPrototypeOf(Bar)).apply(this, arguments));

        _this.state = {
            isDragging: false
        };
        _this.onBarClick = function (event) {
            event.stopPropagation();
        };
        _this.onDocumentSelectStart = function (event) {
            event.preventDefault();
            event.stopPropagation();
            return false;
        };
        _this.onDocumentMouseMove = function (event) {
            var onBarDrag = _this.props.onBarDrag;

            onBarDrag && onBarDrag(event);
        };
        _this.onDragEnd = function (event) {
            _this._stopDrag(event);
        };
        _this.onDocumentMouseUp = function (event) {
            _this._stopDrag(event);
        };
        _this._stopDrag = function (event) {
            var onBarDrag = _this.props.onBarDrag;

            _this.setState({
                isDragging: false
            });
            onBarDrag && onBarDrag(event);
        };
        _this.onBarMouseDown = function (event) {
            var onBarDragStart = _this.props.onBarDragStart;

            onBarDragStart && onBarDragStart(event);
            _this.setState({
                isDragging: true
            });
        };
        return _this;
    }

    _createClass(Bar, [{
        key: 'render',
        value: function render() {
            var isDragging = this.state.isDragging;

            var eventListenerProps = {
                target: 'window',
                capture: true
            };
            if (isDragging) {
                eventListenerProps = Object.assign({}, eventListenerProps, { onMouseUp: this.onDocumentMouseUp, onMouseMove: this.onDocumentMouseMove, onSelectStart: this.onDocumentSelectStart, onDragEnd: this.onDragEnd });
            }
            var barProps = {
                onMouseDown: this.onBarMouseDown,
                onClick: this.onBarClick,
                className: this.props.theme.container
            };
            return _react2.default.createElement(_EventListener.EventListener, Object.assign({}, eventListenerProps), _react2.default.createElement("div", Object.assign({}, barProps)));
        }
    }]);

    return Bar;
}(_react2.default.Component);
exports.Bar = Bar = tslib_1.__decorate([_pure.PURE], Bar);
exports.Bar = Bar;