'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ToggleButtons = exports.TOGGLE_BUTTONS = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _pure = require('../../utils/pure');

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _withTheme = require('../../utils/withTheme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TOGGLE_BUTTONS = exports.TOGGLE_BUTTONS = Symbol('ToggleButtons');
var RawToggleButtons = function (_Component) {
    _inherits(RawToggleButtons, _Component);

    function RawToggleButtons() {
        _classCallCheck(this, RawToggleButtons);

        var _this = _possibleConstructorReturn(this, (RawToggleButtons.__proto__ || Object.getPrototypeOf(RawToggleButtons)).apply(this, arguments));

        _this.state = {
            toggleIndex: 0
        };
        _this.renderToggleItem = function (child, i) {
            var _classnames;

            var _this$props = _this.props,
                theme = _this$props.theme,
                isVertical = _this$props.isVertical,
                isDisabled = _this$props.isDisabled;

            var isActive = i === _this.state.toggleIndex;
            var toggleButtonTheme = (0, _withTheme.mergeThemes)({
                container: (0, _classnames3.default)(theme.container__item, (_classnames = {}, _defineProperty(_classnames, theme.container__item_active, isActive), _defineProperty(_classnames, theme.container__vertical, isVertical), _classnames))
            }, child.props.theme || {});
            var childProps = Object.assign({}, child.props, {
                isActive: isActive,
                isDisabled: isDisabled,
                onClick: _this.onToggleSelect(i, child.props.onClick),
                theme: toggleButtonTheme
            });
            return React.cloneElement(child, childProps);
        };
        _this.onToggleSelect = function (toggleIndex, childClickHandler) {
            return function () {
                if (typeof _this.props.toggleIndex === 'undefined') {
                    _this.setState({
                        toggleIndex: toggleIndex
                    });
                }
                childClickHandler && childClickHandler();
                _this.props.onChange && _this.props.onChange(toggleIndex);
            };
        };
        return _this;
    }

    _createClass(RawToggleButtons, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            var _props = this.props,
                toggleIndex = _props.toggleIndex,
                defaultIndex = _props.defaultIndex;

            this.setState({
                toggleIndex: typeof toggleIndex !== 'undefined' ? toggleIndex : defaultIndex || 0
            });
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            if (typeof newProps.toggleIndex !== 'undefined') {
                this.setState({
                    toggleIndex: newProps.toggleIndex
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                children = _props2.children,
                theme = _props2.theme;

            return React.createElement("div", { className: theme.container__wrapper }, React.Children.map(children, this.renderToggleItem));
        }
    }]);

    return RawToggleButtons;
}(_react.Component);
RawToggleButtons.propTypes = {
    children: _react.PropTypes.arrayOf(_react.PropTypes.element),
    isDisabled: _react.PropTypes.bool,
    isVertical: _react.PropTypes.bool,
    toggleIndex: _react.PropTypes.number,
    defaultIndex: _react.PropTypes.number,
    onChange: _react.PropTypes.func,
    theme: _react.PropTypes.shape({
        container: _react.PropTypes.string,
        container__wrapper: _react.PropTypes.string,
        container__vertical: _react.PropTypes.string,
        container__item: _react.PropTypes.string,
        container__item_active: _react.PropTypes.string
    })
};
RawToggleButtons = tslib_1.__decorate([_pure.PURE], RawToggleButtons);
var ToggleButtons = exports.ToggleButtons = (0, _withTheme.withTheme)(TOGGLE_BUTTONS)(RawToggleButtons);